﻿Public Class calculate

    Public Structure interval
        Public startDate As Date
        Public endDate As Date
        Public years As Integer
        Public months As Integer
        Public days As Integer
    End Structure

    Public Shared Sub calculateTime(ByRef timeInterval As interval)

        Dim ed As Date = timeInterval.endDate
        Dim sd As Date = timeInterval.startDate

        Dim totalDays As Integer = CInt((ed - sd).TotalDays)

        Dim totalMonths As Integer = countMonths(totalDays, sd)
        
        Dim monthDaySum As Integer = (Enumerable.Range(0, totalMonths).Select(Function(i) _
                                        Date.DaysInMonth(sd.AddMonths(i).Year, sd.AddMonths(i).Month))).Sum

        If sd.Day > Date.DaysInMonth(sd.AddMonths(totalMonths).Year, sd.AddMonths(totalMonths).Month) Then
            monthDaySum -= (sd.Day - Date.DaysInMonth(sd.AddMonths(totalMonths).Year, sd.AddMonths(totalMonths).Month))
        End If

        If monthDaySum > 0 Then totalDays -= monthDaySum

        Dim totalYears As Integer = totalMonths \ 12
        totalMonths = totalMonths Mod 12

        timeInterval.years = totalYears
        timeInterval.months = totalMonths
        timeInterval.days = totalDays

    End Sub

    Private Shared Function countMonths(ByVal totalDays As Integer, ByVal d1 As Date) As Integer
        Dim sum As Integer = 0
        Dim counter As Integer = 0
        Do
            sum += Date.DaysInMonth(d1.Year, d1.Month)
            If sum <= totalDays Then
                d1 = d1.AddMonths(1)
                counter += 1
            Else
                Exit Do
            End If
        Loop
        Return counter
    End Function

End Class
